# mle.R 
# 9/14/04 
# Defines seed values and defines likelihood function 
 
#rm(list=ls()) 
  
#xx <- read.table("C:/Data/Media/scratch2.txt",header=T) 
 
#TotalOutlets = 20 
 
x      = AvReSc99[(NewsID == 0 | (NewsID < TotalOutlets +1 ) )] 
y      = NewThTaID[(NewsID == 0 | (NewsID < TotalOutlets +1 ) )]
TempID = NewsID[(NewsID == 0 | (NewsID < TotalOutlets +1 ) )] 
 
####  delete some think tanks so total number is <= 50  ###### 
# Do this if you want to use Stata's mlogit to make seed values 
# for the a's and b's 
 
#x       =      x[(y<36 | y > 70)] 
#TempID  = TempID[(y<36 | y > 70)] 
#y       =      y[(y<36 | y > 70)] 
 
################  Create seed values  ############################# 
a.seed = rep(50,ttN-1) 
b.seed = rep(50,ttN-1) 
gam.seed = rep(50,TotalOutlets) 
 
 
beta.seed = c(a.seed, b.seed, gam.seed) 
 
####### Create initial values for x vector ############ 
# x begins with ADA scores of legislators and seed ADA scores (gam.seed) 
# of the media outlets.  In the likelihood function the program 
# replaces the x's of the media outlets with the estimates of gamma 
# (ie the c_j's). 
 
for (j in 1:TotalOutlets){ x = ifelse(TempID == j,gam.seed[j],x) } 
 
 
####### Define the likelihood function ################ 
 
m.log.like = function(beta,y,x){ 
  a = rep(0,ttN) 
  a[2:ttN] = beta[1:(ttN-1)] 
  b = rep(0,ttN) 
  b[2:ttN] = beta[ttN:(2*ttN-2)] 
  gam = rep(0,TotalOutlets) 
  gam[1:TotalOutlets] = beta[(2*ttN-1):(length(beta))] 
  for (j in 1:TotalOutlets){ 
    x = ifelse(TempID == j,gam[j],x) 
  } 
  Num = rep(0,length(y)) 
  for (j in 1:ttN){ 
    Num = ifelse(y==j,exp(a[j]+b[j]*x),Num) 
  } 
  Denom = rep(0,length(y)) 
  for (j in 1:ttN){ 
    Denom = Denom + exp(a[j]+b[j]*x) 
  } 
  sum( - log(Num/Denom) ) 
} 
 
 
######## Define the likelihood function for ceter.-parib. estimates ##### 
# For these estimates all a's and b's are held at their seed values. 
# Also all gamma_k's (ie c_k's) are held at their seed values except 
# for media outlet j.  It's gamma_j is estimated. 
 
mx.log.like = function(gam.j,y,x){ 
  beta.seed[(2*ttN-2+j)] = gam.j 
  result = m.log.like(beta.seed,y,x) 
  result 
} 
 
######## Useful commands to run in R (so I don't have to re-type them ######### 
# source("C:/Documents and Settings/tim/My Documents/Media.Bias.2004.08/desc.R") 
# source("C:/Documents and Settings/tim/My Documents/Media.Bias.2004.08/mle.R") 
# source("C:/Documents and Settings/tim/My Documents/Media.Bias.2004.08/get.cet.par.ada.R") 
# med.ada 
# result = nlm(mx.log.like,gam.seed[j],hessian=T,print.level=2,iterlim=200,y=y,x=x) 
# result = nlm(m.log.like,beta.seed,hessian=T,print.level=2, iterlim=200,y=y,x=x) 
 
## After program has converged, enter the following commands in R to get 
## standard errors of the gamma_j's (ie c_j's) 
# BigSig = result$hessian^(-1) 
# sd = rep(0,20) 
# for (j in (2*ttN-1):(2*ttN-2+TotalOutlets) )  {sd[j-(2*ttN-2)] =sqrt(BigSig[j,j])} 
 
# xx=cbind(x,y) 
# write.table(xx,"C:/Data/Media/scratch3.txt") 
## Use the above commands to create a file for Stata.  Go to excel and 
## delete the first row and first column.  In stata enter: 
## clear all 
## set memory 128M 
## set matsize 300 
## infile x y using "C:/Data/Media/scratch3.txt" 
## mlogit y x, base(1) 
 
# Act-70,mega-6, w/ ACLU.  These should converge after 5-10 iterations 
#59.46582 62.07027 68.48882 74.42036 55.78312 60.66869 69.69691 63.17545 66.07261 74.41651 
#57.92183 67.38706 67.48543 41.90837 65.39664 66.72007 64.05646 86.01678 66.56443 36.03530 
# mean = 63.688     
