# mle.R
# 9/14/04
# Defines seed values and defines likelihood function

#rm(list=ls())
 
#xx <- read.table("C:/Data/Media/scratch2.txt",header=T)

#TotalOutlets = 20

x      = AvReSc99[(NewsID == 0 | (NewsID < TotalOutlets +1 ) )]
y      = NewThTaID[(NewsID == 0 | (NewsID < TotalOutlets +1 ) )]
TempID = NewsID[(NewsID == 0 | (NewsID < TotalOutlets +1 ) )]

####  delete some think tanks so total number is <= 50  ######
# Do this if you want to use Stata's mlogit to make seed values
# for the a's and b's

#x       =      x[(y<36 | y > 70)]
#TempID  = TempID[(y<36 | y > 70)]
#y       =      y[(y<36 | y > 70)]

################  Create seed values  #############################
a.seed = rep(50,ttN-1)
b.seed = rep(50,ttN-1)
#gam.seed = rep(0,TotalOutlets)

#a.seed[1:10]   = c( -0.9417304, -0.9887754, -2.3009470, -2.0126740, -1.6482180, -2.5129230, -2.3976390, -1.3830470, -1.8095820, -1.7441400)
#a.seed[11:20]  = c( -2.2370910, -2.7384350, -2.8049850, -3.1526060, -4.2003760, -1.1777940, -1.0118910, -3.5216060, -2.9665520, -3.6314360)
#a.seed[21:30]  = c( -1.1353080, -3.6139340, -4.6355420, -6.6532470, -1.7181690, -3.8548790, -3.6897880, -2.3950820, -3.9095660, -3.5575680)
#a.seed[31:40]  = c( -5.8529870, -3.3286150, -0.5894838, -3.9784080, -3.6037570, -4.7403970, -3.9621670, -0.4862836, -6.7518920, -0.4772222)
#a.seed[41:(ActualThTaN-1)] = c(-1.7940830, -0.0683571, -4.3240700)
#a.seed[ActualThTaN:(ttN-1)]= c( 0.7373750, -0.1731141, -1.2030340, -1.5388080, -2.7974410, -4.3738660)

#b.seed[1:10]   = c(0.0379098, 0.0347679, 0.0449945, 0.0356761, 0.0372963, 0.0415489, 0.0480110, 0.0256937, 0.0375306, 0.0300879)
#b.seed[11:20]  = c(0.0451031, 0.0413935, 0.0479321, 0.0470539, 0.0668265, 0.0139359, 0.0136248, 0.0484263, 0.0398275, 0.0554376)
#b.seed[21:30]  = c(0.0083141, 0.0440312, 0.0648216, 0.0939203, 0.0117285, 0.0426869, 0.0393450, 0.0287267, 0.0392917, 0.0369625)
#b.seed[31:40]  = c(0.0827286, 0.0333433, 0.0051106, 0.0460668, 0.0467094, 0.0520144, 0.0361750, -0.0115429, 0.0857054, -0.0036267)
#b.seed[41:(ActualThTaN-1)]  = c( 0.0058778, 0.0006778, 0.0445496)
#b.seed[ActualThTaN:(ttN-1)] = c(-0.0076064, 0.0052294, 0.0242500, 0.0357602, 0.0532828, 0.0701544)



beta.seed = c(a.seed, b.seed, gam.seed)

####### Create initial values for x vector ############
# x begins with ADA scores of legislators and seed ADA scores (gam.seed)
# of the media outlets.  In the likelihood function the program
# replaces the x's of the media outlets with the estimates of gamma
# (ie the c_j's).

for (j in 1:TotalOutlets){ x = ifelse(TempID == j,gam.seed[j],x) }


####### Define the likelihood function ################

m.log.like = function(beta,y,x){
  a = rep(0,ttN)
  a[2:ttN] = beta[1:(ttN-1)]
  b = rep(0,ttN)
  b[2:ttN] = beta[ttN:(2*ttN-2)]
  gam = rep(0,TotalOutlets)
  gam[1:TotalOutlets] = beta[(2*ttN-1):(length(beta))]
  for (j in 1:TotalOutlets){
    x = ifelse(TempID == j,gam[j],x)
  }
  Num = rep(0,length(y))
  for (j in 1:ttN){
    Num = ifelse(y==j,exp(a[j]+b[j]*x),Num)
  }
  Denom = rep(0,length(y))
  for (j in 1:ttN){
    Denom = Denom + exp(a[j]+b[j]*x)
  }
  sum( - log(Num/Denom) )
}


######## Define the likelihood function for ceter.-parib. estimates #####
# For these estimates all a's and b's are held at their seed values.
# Also all gamma_k's (ie c_k's) are held at their seed values except
# for media outlet j.  It's gamma_j is estimated.

mx.log.like = function(gam.j,y,x){
  beta.seed[(2*ttN-2+j)] = gam.j
  result = m.log.like(beta.seed,y,x)
  result
}

######## Useful commands to run in R (so I don't have to re-type them #########
# source("C:/Documents and Settings/tim/My Documents/Media.Bias.2004.08/desc.R")
# source("C:/Documents and Settings/tim/My Documents/Media.Bias.2004.08/mle.R")
# source("C:/Documents and Settings/tim/My Documents/Media.Bias.2004.08/get.cet.par.ada.R")
# med.ada
# result = nlm(mx.log.like,gam.seed[j],hessian=T,print.level=2,iterlim=200,y=y,x=x)
# result = nlm(m.log.like,beta.seed,hessian=T,print.level=2, iterlim=200,y=y,x=x)

## After program has converged, enter the following commands in R to get
## standard errors of the gamma_j's (ie c_j's)
# BigSig = result$hessian^(-1)
# sd = rep(0,20)
# for (j in (2*ttN-1):(2*ttN-2+TotalOutlets) )  {sd[j-(2*ttN-2)] =sqrt(BigSig[j,j])}

# xx=cbind(x,y)
# write.table(xx,"C:/Data/Media/scratch3.txt")
## Use the above commands to create a file for Stata.  Go to excel and
## delete the first row and first column.  In stata enter:
## clear all
## set memory 128M
## set matsize 300
## infile x y using "C:/Data/Media/scratch3.txt"
## mlogit y x, base(1)

# Act-70,mega-6, w/ ACLU.  These should converge after 5-10 iterations
#59.46582 62.07027 68.48882 74.42036 55.78312 60.66869 69.69691 63.17545 66.07261 74.41651
#57.92183 67.38706 67.48543 41.90837 65.39664 66.72007 64.05646 86.01678 66.56443 36.03530
# mean = 63.688
