
###########
## Figure 1
## This code generates the file total.tt.overtime.pdf



library(ggplot2)

## v2 caps the total citations at 250.
data <- read.csv("total.tt.overtime.v2.csv")
#data <- data[order(data$outlet),]# drop outlet ID
data <- data[,-2]
row.names(data) <- data$X
for(i in 2:length(colnames(data))){ colnames(data)[i] <- substring(colnames(data)[i], 2, 5)}

data.m <- melt(data)
(p <- ggplot(data.m, aes(variable, X)) + geom_tile( aes(fill = value), colour = "white") + scale_fill_gradient2(midpoint = 0, high = muted("red") , space = "Lab") )
base_size <- 12

#pdf(file = "total.tt.overtime.pdf")
p + theme_bw(base_size = base_size) + labs(x = "Year", y = "") + scale_x_discrete(expand = c(0, 0)) + scale_y_discrete(expand = c(0, 0)) + opts( axis.ticks = theme_blank(), axis.text.x = theme_text(size = base_size * 0.8, angle = 300, hjust = 0, colour = "black"))
#dev.off()



###########
## Figure 2
## This code generates the file tt.congXmed.pdf

yy <- read.table("newscong.txt",header=T)
yy$count <- rep(1,nrow(yy))

ttnames <- read.csv("tt.names.csv", header = TRUE)


zz <- yy
zz$NewsID[zz$NewsID>0] <- 1

foo <- aggregate(yy$count, by=list(tt = yy$ThTaID), sum)
foo$rank[order(-foo$x)] <- 1:nrow(foo)

tmp <- aggregate(yy$count, by=list(tt = yy$ThTaID, year = yy$Year, newsid = yy$NewsID), sum)
tmp2 <- aggregate(zz$count, by=list(tt = zz$ThTaID, year = zz$Year, newsid = zz$NewsID), sum)
tmp3 <- aggregate(zz$count, by=list(tt = zz$ThTaID,  newsid = zz$NewsID), sum)
tmp3 <- tmp3[tmp3$newsid == 0,]
tmp3$rank[order(-tmp3$x)] <- 1:nrow(tmp3)
tmp3 <- tmp3[,c(1,4)]


tmp2$newsid[tmp2$newsid==1] <- "Media"
tmp2$newsid[tmp2$newsid==0] <- "Congress"

tmp4 <- merge(tmp2, tmp3)

tmp5 <- aggregate(zz$count, by=list(tt = zz$ThTaID,  newsid = zz$NewsID), sum)
tmp5 <- tmp5[tmp5$newsid == 1,]
tmp5$rank[order(-tmp5$x)] <- 1:nrow(tmp5)
tmp5 <- tmp5[,c(1,4)]


library(ggplot2)


p1 <- ggplot(tmp4, aes(year, rank)) + geom_tile(aes(alpha = x) , colour = "white") +scale_alpha("x", breaks = c(100,200,300,400) )#+ scale_fill_gradient(midpoint = 0, low = "grey", high = "black")

base_size <- 8
p1 <- p1 + theme_bw(base_size = base_size) + labs(x = "Year", y = "Think Tanks")  + opts( axis.ticks = theme_blank(), axis.text.x = theme_text(size = base_size * 0.8, angle = 330, hjust = 0, colour = "black")) # + scale_x_discrete(expand = c(0, 0))
#pdf(file = "tt.congXmed.pdf")
p1 + facet_wrap(~ newsid)
#dev.off()


newsnames <- read.csv(file = "../newsid.csv", header = TRUE)
tmp <- merge(tmp,newsnames, by = "newsid", all.x = TRUE)
tmp2 <- merge(tmp2,newsnames, by = "newsid", all.x = TRUE)

p2 <- ggplot(tmp[tmp$newsid>0 & tmp$newsid != 9 ,], aes(year, tt)) + geom_tile(aes(fill = x) , colour = "white") +  scale_fill_gradient2( midpoint = -5, high = muted("red"))

p2 <- ggplot(tmp[tmp$newsid==14 | tmp$newsid==4 | tmp$newsid==8 | tmp$newsid==15 ,], aes(year, tt)) + geom_tile(aes(fill = x) , colour = "white") +  scale_fill_gradient2( midpoint = -5, high = "red")

base_size <- 8
p2 <- p2 + theme_bw(base_size = base_size) + labs(x = "Year", y = "Think Tanks", main = "News 1")  + opts( axis.ticks = theme_blank(), axis.text.x = theme_text(size = base_size * 0.8, angle = 330, hjust = 0, colour = "black")) # + scale_x_discrete(expand = c(0, 0))
#pdf(file = "ttbyoutlet.pdf")
p2 + facet_wrap(~name)
#dev.off()




###########
## Figure 3
## This code generates the file "overtime.results.pdf" 

results <- read.csv("results.alloutlets.csv")


#Newsweek doesn't start until mid 1995.  Estimation in 1993-1996 is suspect.
results$estimate.Newsweek[1] <- NA
results$sd.Newsweek[1] <- NA



years<-c(1993,1994,1995,1996,1997,1998,1999,2000)

#pdf(file= "overtime.results.pdf", width = 8, height = 4)
par(mfrow= c(1,3))
outlets<- c("CBS","ABC","NBC")

plot(results$estimate.CBS ~ years,col="black",
       type="b",
       pch=19,
       ylim=c(10,90),
       ylab="Adjusted ADA Score",
       xlab="Data pooled over 4-year moving time frames",
       lty=3,#0=blank, 1=solid, 2=dashed, 3=dotted, 4=dotdash, 5=longdash, 6=twodash)
       cex=1.2,
       xaxt="n",      
       )  
#     main=""Estimated Adjusted ADA Score of Media Outlets\n with 95% Confidence Bands",
axis(1, years,c("1993-1996","1994-1997","1995-1998","1996-1999","1997-2000","1998-2001","1999-2002","2000-2003")) 
polygon(c(years,rev(years)),c(results$estimate.CBS+1.96*results$sd.CBS,rev(results$estimate.CBS - 1.96*results$sd.CBS)), density=10,angle=45)

points(results$estimate.ABC~years,type="b",pch=17,lty=3,cex=1.2)
polygon(c(years,rev(years)),c(results$estimate.ABC+1.96*results$sd.ABC,rev(results$estimate.ABC - 1.96*results$sd.ABC)), density=10,angle=90)

points(results$estimate.NBC~years,type="b",pch=15,lty=3,cex=1.2)
polygon(c(years,rev(years)),c(results$estimate.NBC+1.96*results$sd.NBC,rev(results$estimate.NBC - 1.96*results$sd.NBC)), density=25,angle=45)

legend("topright",outlets,pch=c(19,17,15),angle=c(45,90,45),density=c(10,10,25),cex=1.5)


outlets<- c("NPR","Fox","NewsHour")

plot(results$estimate.NPR ~ years,col="black",
       type="b",
       pch=19,
       ylim=c(10,90),
       ylab="Adjusted ADA Score",
       xlab="Data pooled over 4-year moving time frames",
       lty=3,#0=blank, 1=solid, 2=dashed, 3=dotted, 4=dotdash, 5=longdash, 6=twodash)
       cex=1.2,
       xaxt="n",      
       )      
#       main="Estimated Adjusted ADA Score of Media Outlets\n with 95% Confidence Bands",


axis(1, years,c("1993-1996", "1994-1997", "1995-1998", "1996-1999", "1997-2000", "1998-2001", "1999-2002", "2000-2003")) 
polygon(c(years,rev(years)),c(results$estimate.NPR+1.96*results$sd.NPR,rev(results$estimate.NPR - 1.96*results$sd.NPR)), density=10,angle=45)


points(results$estimate.Fox ~ years,type="b",pch=17,lty=3,cex=1.2)
polygon(c(years,rev(years)),c(results$estimate.Fox+1.96*results$sd.Fox,rev(results$estimate.Fox - 1.96*results$sd.Fox)),  density=10,angle=90)


points(results$estimate.NewsHour ~ years,type="b",pch=17,lty=3,cex=1.2)
polygon(c(years,rev(years)),c(results$estimate.NewsHour+1.96*results$sd.NewsHour,rev(results$estimate.NewsHour - 1.96*results$sd.NewsHour)),   density=25,angle=45)
legend("topright",outlets,pch=c(19,17,15),angle=c(45,90,45),density=c(10,10,25),cex=1.5)




outlets<- c("US News","NY Times","Newsweek")

plot(results$estimate.USNews~years,col="black",
       type="b",
       pch=19,
       ylim=c(10,90),
       ylab="Adjusted ADA Score",
       xlab="Data pooled over 4-year moving time frames",
       lty=3,#0=blank, 1=solid, 2=dashed, 3=dotted, 4=dotdash, 5=longdash, 6=twodash)
       cex=1.2,
       xaxt="n",      
       )      
#       main="Estimated Adjusted ADA Score of Media Outlets\n with 95% Confidence Bands",
       
axis(1, years,c("1993-1996", "1994-1997", "1995-1998", "1996-1999", "1997-2000", "1998-2001", "1999-2002", "2000-2003")) 
polygon(c(years,rev(years)),c(results$estimate.USNews+1.96*results$sd.USNews,rev(results$estimate.USNews - 1.96*results$sd.USNews)), density=10,angle=45)

points(results$estimate.NYTimes~years,type="b",pch=17,lty=3,cex=1.2)
polygon(c(years,rev(years)),c(results$estimate.NYTimes + 1.96*results$sd.NYTimes,rev(results$estimate.NYTimes - 1.96*results$sd.NYTimes)), density=10,angle=90)

points(results$estimate.Newsweek ~ years,type="b",pch=15,lty=3,cex=1.2)
polygon(c(years,rev(years)),c(results$estimate.Newsweek+1.96*results$sd.Newsweek,rev(results$estimate.Newsweek - 1.96*results$sd.Newsweek)), density=25,angle=45,col=)
legend("topright",outlets,pch=c(19,17,15),angle=c(45,90,45),density=c(10,10,25),cex=1.5)

#dev.off()








###########
## Figure 4
## This code generates the files "id.9396.pdf" and "id.0003.pdf" which form figure 4

library(lattice)
ttid <- c("Heritage Foundation", "NRA", "Christian Coalition", "Economic Policy Institute", "NAACP", "Sierra Club")

## These estimates and errors come from results in the IDtest folder.
est.9396 <- c(69.4, 66.9, 66.91, 66.91, 66.9, 66.92)      #c(65.94, 66.906, 66.905, 66.908, 66.906, 66.923)
se.9396 <- c(3.16, 3.097, 3.1,  3.097, 3.09, 3.18)       #c(3.081, 3.097, 3.097, 3.097, 3.097, 3.179)

est.0003 <- c(51.7, 51.38, 51.38, 51.37, 51.38, 51.38)      #c(51.373, 51.379, 51.374, 51.370, 51.376, 51.376)
se.0003 <-  c(3.18, 3.16, 3.16, 3.16, 3.16,  3.16)     #c(3.161, 3.161, 3.161, 3.162, 3.161, 3.161)



#par(mfrow = c(2,1), pty = "s")
#pdf(file = "id.9396.pdf")
dotplot(ttid ~ est.9396, xlim = c(40, 80), xlab = "From 1993 through 1996",col ="black",
        panel = function (x, y) {
          panel.abline(v=0)
          panel.xyplot(x, y, pch = 16, col = "black") 
        panel.segments(est.9396 - 2*se.9396, as.numeric(y),
                       est.9396 + 2*se.9396, as.numeric(y), lty = 1, col = "black")
        } )
#dev.off()



#pdf(file = "id.0003.pdf")
dotplot(ttid ~ est.0003, xlim = c(40, 80), xlab = "From 2000 through 2003",col ="black",
        panel = function (x, y) {
          panel.abline(v=0)
          panel.xyplot(x, y, pch = 16, col = "black") 
        panel.segments(est.0003 - 2*se.0003, as.numeric(y),
                       est.0003 + 2*se.0003, as.numeric(y), lty = 1, col = "black")
        } ) 
#dev.off()



