# desc.R
# 8/26/04 
# Computes descriptive stats, including back of the env. estimates for Media Bias paper. 
 
 
########################## Clear memory ############################## 
#rm(list=ls()) 
 
################# Define constants and set parmeters ################# 
 
# Center defined by midpoint of (i) senate ave, weighted by population and 
# (ii) House ave.  Both computed with phantom D.C. legislators with highest 
# possible lib score.  Both averaged over the period 1995-99. 
Center = 50.06 
 
CutPoint = 50.06 
# Used for Back of the Envelope calculations 
 
# Omit observations in which the legislator or reporter criticized the think tank? 
OmitCrits = T 
 
# Omit obseravtions in which the legislator or reporter gave the th. t. an ideological label? 
OmitLabels = T 
 
# Omit Different outlets?
OmitABCMorning        = T  #************* Omitting ********
                         
OmitABC               = T  #************* Omitting ********

OmitCBSEarly          = F
                          
OmitCBS               = T  #************* Omitting ********
                           
OmitCNN               = T  #************* Omitting ********    
                           
OmitDrudge            = T  #************* Omitting ********  
                           
OmitLATimes           = T  #************* Omitting ********  
                           
OmitNBC1              = T  #************* Omitting ********
                           
OmitNBC2              = T  #************* Omitting ********
                           
OmitNBCToday          = T  #************* Omitting ********
                           
OmitNYTimes           = T  #************* Omitting ******** 
                           
OmitNewsHour          =  T  #************* Omitting ******** 
                           
OmitNewsweek          = T  #************* Omitting ********
                           
OmitNPR               = T  #************* Omitting ********
                           
OmitFox               = T  #************* Omitting ********
                           
OmitTime              = T  #************* Omitting ********
  
OmitUSNews            = T  #************* Omitting ********
                           
OmitUSAToday          = T  #************* Omitting ********
                           
OmitJournal           = T  #************* Omitting ********
                           
OmitWashPost          = T  #************* Omitting ********

OmitWashTimes         = T  #************* Omitting ********






# Omit ACLU data? 
OmitACLU = F 

#Omit problematic TT from90-99?
OmitTT9099 = F

#Omit problematic TT from 2000-2004?
OmitTT0004 = F

# Number of Actual and Mega Think tanks 
ActualThTaN = 30
MegaThTaN  = 10
 
 
########################## Load Data ################################ 
 
##  You might need to edit the folder name that contains newscong.txt.  Or just make sure 
##  it is in the folder called "C:/Documents and Settings/Tim/My Documents/Media.Bias.2004.08" 
#xx <- read.table("C:/Documents and Settings/Tim/My Documents/Media.Bias.2004.08/newscong.txt",header=T) 
##  On Desktop, do not capitalize "Tim" 
#  xx <- read.table("C:/Documents and Settings/John Gasper/My Documents/CGIS N/GMData/time split/newscong9099.txt",header=T) 
  mainxx <- read.table("../newscong.9801.txt",header=T) 

if (bootstrap){
  xx <- mainxx[sample(1:nrow(mainxx),replace=T),]
}else{ xx <- mainxx}
#xx <- mainxx

NewsID   = xx$NewsID 
NumDate  = xx$NumDate 
AvReSc99 = xx$AvReSc99 
Sents    = xx$Sents 
ThTaID   = xx$ThTaID 
Page1    = xx$Page1 
Critic   = xx$Critic 
Label    = xx$Label 
CIdeo    = xx$CIdeo 
Party    = xx$Party



############ RECODING #########
#library(car)
#print("Switching TT 1 with TT 50")
#ThTaID = recode(ThTaID, "1=9999")
#ThTaID = recode(ThTaID, "50=1")
#ThTaID = recode(ThTaID, "9999=50")
 
####################### Create quality variables  ################################ 
 
TotalObs = length(NewsID) 
 
print(TotalObs) 
 
if (OmitCrits) { 
  NewsID   = NewsID[Critic==0] 
  NumDate  = NumDate[Critic==0] 
  AvReSc99 = AvReSc99[Critic==0] 
  Sents    = Sents[Critic==0] 
  ThTaID   = ThTaID[Critic==0] 
  Page1    = Page1[Critic==0] 
  CIdeo    = CIdeo[Critic==0] 
  Party    = Party[Critic==0] 
  Label    = Label[Critic==0] 
  Critic   = Critic[Critic==0] 
} 
 
 
if (OmitLabels) { 
  NewsID   = NewsID[Label==0] 
  NumDate  = NumDate[Label==0] 
  AvReSc99 = AvReSc99[Label==0] 
  Sents    = Sents[Label==0] 
  ThTaID   = ThTaID[Label==0] 
  Page1    = Page1[Label==0] 
  CIdeo    = CIdeo[Label==0] 
  Party    = Party[Label==0] 
  Critic   = Critic[Label==0]   
  Label    = Label[Label==0] 
} 
 
if (OmitWashTimes) {
  print("Omitting Washington Times ID=21")

  NumDate  = NumDate[NewsID !=21] 
  AvReSc99 = AvReSc99[NewsID !=21] 
  Sents    = Sents[NewsID !=21]
  ThTaID   = ThTaID[NewsID !=21]
  Page1    = Page1[NewsID !=21]
  CIdeo    = CIdeo[NewsID !=21]
  Party    = Party[NewsID !=21]
  Critic   = Critic[NewsID !=21] 
  Label    = Label[NewsID !=21]
  NewsID   = NewsID[NewsID !=21]
}

if (OmitWashPost) {
  print("Omitting Washington Post ID=20")

    outlet = 20
  
  NumDate  = NumDate[NewsID !=outlet] 
  AvReSc99 = AvReSc99[NewsID !=outlet] 
  Sents    = Sents[NewsID !=outlet]
  ThTaID   = ThTaID[NewsID !=outlet]
  Page1    = Page1[NewsID !=outlet]
  CIdeo    = CIdeo[NewsID !=outlet]
  Party    = Party[NewsID !=outlet]
  Critic   = Critic[NewsID !=outlet] 
  Label    = Label[NewsID !=outlet]
  NewsID   = NewsID[NewsID !=outlet]
  for (j in (outlet+1):21){ 
    NewsID = ifelse(NewsID==j,j-1,NewsID) 
  } 
}

  
if (OmitJournal) {
  print("Omitting Wall Street Journal ID=19")

    outlet = 19
  
  NumDate  = NumDate[NewsID !=outlet] 
  AvReSc99 = AvReSc99[NewsID !=outlet] 
  Sents    = Sents[NewsID !=outlet]
  ThTaID   = ThTaID[NewsID !=outlet]
  Page1    = Page1[NewsID !=outlet]
  CIdeo    = CIdeo[NewsID !=outlet]
  Party    = Party[NewsID !=outlet]
  Critic   = Critic[NewsID !=outlet] 
  Label    = Label[NewsID !=outlet]
  NewsID   = NewsID[NewsID !=outlet]
  for (j in (outlet+1):21){ 
    NewsID = ifelse(NewsID==j,j-1,NewsID) 
  } 
}


if (OmitUSAToday) {
  print("Omitting USA Today ID=18")
 
    outlet = 18
  
  NumDate  = NumDate[NewsID !=outlet] 
  AvReSc99 = AvReSc99[NewsID !=outlet] 
  Sents    = Sents[NewsID !=outlet]
  ThTaID   = ThTaID[NewsID !=outlet]
  Page1    = Page1[NewsID !=outlet]
  CIdeo    = CIdeo[NewsID !=outlet]
  Party    = Party[NewsID !=outlet]
  Critic   = Critic[NewsID !=outlet] 
  Label    = Label[NewsID !=outlet]
  NewsID   = NewsID[NewsID !=outlet]
  for (j in (outlet+1):21){ 
    NewsID = ifelse(NewsID==j,j-1,NewsID) 
  } 
}



if (OmitUSNews) {
  print("Omitting US News ID=17")
 
  outlet = 17
  
  NumDate  = NumDate[NewsID !=outlet] 
  AvReSc99 = AvReSc99[NewsID !=outlet] 
  Sents    = Sents[NewsID !=outlet]
  ThTaID   = ThTaID[NewsID !=outlet]
  Page1    = Page1[NewsID !=outlet]
  CIdeo    = CIdeo[NewsID !=outlet]
  Party    = Party[NewsID !=outlet]
  Critic   = Critic[NewsID !=outlet] 
  Label    = Label[NewsID !=outlet]
  NewsID   = NewsID[NewsID !=outlet]
  for (j in (outlet+1):21){ 
    NewsID = ifelse(NewsID==j,j-1,NewsID) 
  } 
}


if (OmitTime) {
  print("Omitting Time ID=16")
 
  outlet = 16
  
  NumDate  = NumDate[NewsID !=outlet] 
  AvReSc99 = AvReSc99[NewsID !=outlet] 
  Sents    = Sents[NewsID !=outlet]
  ThTaID   = ThTaID[NewsID !=outlet]
  Page1    = Page1[NewsID !=outlet]
  CIdeo    = CIdeo[NewsID !=outlet]
  Party    = Party[NewsID !=outlet]
  Critic   = Critic[NewsID !=outlet] 
  Label    = Label[NewsID !=outlet]
  NewsID   = NewsID[NewsID !=outlet]
  for (j in (outlet+1):21){ 
    NewsID = ifelse(NewsID==j,j-1,NewsID) 
  } 
}

if (OmitFox) {
  print("Omitting Fox ID=15")

  outlet = 15
  
  NumDate  = NumDate[NewsID !=outlet] 
  AvReSc99 = AvReSc99[NewsID !=outlet] 
  Sents    = Sents[NewsID !=outlet]
  ThTaID   = ThTaID[NewsID !=outlet]
  Page1    = Page1[NewsID !=outlet]
  CIdeo    = CIdeo[NewsID !=outlet]
  Party    = Party[NewsID !=outlet]
  Critic   = Critic[NewsID !=outlet] 
  Label    = Label[NewsID !=outlet]
  NewsID   = NewsID[NewsID !=outlet]
  for (j in (outlet+1):21){ 
    NewsID = ifelse(NewsID==j,j-1,NewsID) 
  } 
}
  
if (OmitNPR) {
  print("Omitting NPR ID=14")
 
  outlet = 14
  
  NumDate  = NumDate[NewsID !=outlet] 
  AvReSc99 = AvReSc99[NewsID !=outlet] 
  Sents    = Sents[NewsID !=outlet]
  ThTaID   = ThTaID[NewsID !=outlet]
  Page1    = Page1[NewsID !=outlet]
  CIdeo    = CIdeo[NewsID !=outlet]
  Party    = Party[NewsID !=outlet]
  Critic   = Critic[NewsID !=outlet] 
  Label    = Label[NewsID !=outlet]
  NewsID   = NewsID[NewsID !=outlet]
  for (j in (outlet+1):21){ 
    NewsID = ifelse(NewsID==j,j-1,NewsID) 
  } 
}
  
if (OmitNewsweek) {
  print("Omitting Newsweek ID=13")
 
  outlet = 13
  
  NumDate  = NumDate[NewsID !=outlet] 
  AvReSc99 = AvReSc99[NewsID !=outlet] 
  Sents    = Sents[NewsID !=outlet]
  ThTaID   = ThTaID[NewsID !=outlet]
  Page1    = Page1[NewsID !=outlet]
  CIdeo    = CIdeo[NewsID !=outlet]
  Party    = Party[NewsID !=outlet]
  Critic   = Critic[NewsID !=outlet] 
  Label    = Label[NewsID !=outlet]
  NewsID   = NewsID[NewsID !=outlet]
  for (j in (outlet+1):21){ 
    NewsID = ifelse(NewsID==j,j-1,NewsID) 
  } 
}

if (OmitNewsHour) {
  print("Omitting NewsHour ID=12")
 
  outlet = 12
  
  NumDate  = NumDate[NewsID !=outlet] 
  AvReSc99 = AvReSc99[NewsID !=outlet] 
  Sents    = Sents[NewsID !=outlet]
  ThTaID   = ThTaID[NewsID !=outlet]
  Page1    = Page1[NewsID !=outlet]
  CIdeo    = CIdeo[NewsID !=outlet]
  Party    = Party[NewsID !=outlet]
  Critic   = Critic[NewsID !=outlet] 
  Label    = Label[NewsID !=outlet]
  NewsID   = NewsID[NewsID !=outlet]
  for (j in (outlet+1):21){ 
    NewsID = ifelse(NewsID==j,j-1,NewsID) 
  } 
}

if (OmitNYTimes) {
  print("Omitting NYTimes ID=11")
 
  outlet = 11
  
  NumDate  = NumDate[NewsID !=outlet] 
  AvReSc99 = AvReSc99[NewsID !=outlet] 
  Sents    = Sents[NewsID !=outlet]
  ThTaID   = ThTaID[NewsID !=outlet]
  Page1    = Page1[NewsID !=outlet]
  CIdeo    = CIdeo[NewsID !=outlet]
  Party    = Party[NewsID !=outlet]
  Critic   = Critic[NewsID !=outlet] 
  Label    = Label[NewsID !=outlet]
  NewsID   = NewsID[NewsID !=outlet]
  for (j in (outlet+1):21){ 
    NewsID = ifelse(NewsID==j,j-1,NewsID) 
  } 
}

if (OmitNBCToday) {
  print("Omitting NBCToday ID=10")
 
  outlet = 10
  
  NumDate  = NumDate[NewsID !=outlet] 
  AvReSc99 = AvReSc99[NewsID !=outlet] 
  Sents    = Sents[NewsID !=outlet]
  ThTaID   = ThTaID[NewsID !=outlet]
  Page1    = Page1[NewsID !=outlet]
  CIdeo    = CIdeo[NewsID !=outlet]
  Party    = Party[NewsID !=outlet]
  Critic   = Critic[NewsID !=outlet] 
  Label    = Label[NewsID !=outlet]
  NewsID   = NewsID[NewsID !=outlet]
  for (j in (outlet+1):21){ 
    NewsID = ifelse(NewsID==j,j-1,NewsID) 
  } 
}


if (OmitNBC2) { 
print("Omitting NBC Nightly News2 ID=9")
  # enter 9's below to use the first set of NBC data 
  # enter 8's to use the second set of NBC data. (and change 10 to 9) 
  NumDate  = NumDate[NewsID !=9] 
  AvReSc99 = AvReSc99[NewsID !=9] 
  Sents    = Sents[NewsID !=9] 
  ThTaID   = ThTaID[NewsID !=9] 
  Page1    = Page1[NewsID !=9] 
  CIdeo    = CIdeo[NewsID !=9] 
  Party    = Party[NewsID !=9] 
  Critic   = Critic[NewsID !=9]  
  Label    = Label[NewsID !=9] 
  NewsID   = NewsID[NewsID !=9] 
  for (j in 10:21){ 
    NewsID = ifelse(NewsID==j,j-1,NewsID) 
  } 
} 

if (OmitNBC1) {
  print("Omitting NBC1 ID=8")
 
  outlet = 8
  
  NumDate  = NumDate[NewsID !=outlet] 
  AvReSc99 = AvReSc99[NewsID !=outlet] 
  Sents    = Sents[NewsID !=outlet]
  ThTaID   = ThTaID[NewsID !=outlet]
  Page1    = Page1[NewsID !=outlet]
  CIdeo    = CIdeo[NewsID !=outlet]
  Party    = Party[NewsID !=outlet]
  Critic   = Critic[NewsID !=outlet] 
  Label    = Label[NewsID !=outlet]
  NewsID   = NewsID[NewsID !=outlet]
  for (j in (outlet+1):21){ 
    NewsID = ifelse(NewsID==j,j-1,NewsID) 
  } 
}

if (OmitLATimes) {
  print("Omitting LA Times ID=7")
 
  outlet = 7
  
  NumDate  = NumDate[NewsID !=outlet] 
  AvReSc99 = AvReSc99[NewsID !=outlet] 
  Sents    = Sents[NewsID !=outlet]
  ThTaID   = ThTaID[NewsID !=outlet]
  Page1    = Page1[NewsID !=outlet]
  CIdeo    = CIdeo[NewsID !=outlet]
  Party    = Party[NewsID !=outlet]
  Critic   = Critic[NewsID !=outlet] 
  Label    = Label[NewsID !=outlet]
  NewsID   = NewsID[NewsID !=outlet]
  for (j in (outlet+1):21){ 
    NewsID = ifelse(NewsID==j,j-1,NewsID) 
  } 
}


if (OmitDrudge) {
  print("Omitting Drudge ID=6")
  # enter 9's below to use the first set of NBC data 
  # enter 8's to use the second set of NBC data. (and change 10 to 9) 
  NumDate  = NumDate[NewsID !=6] 
  AvReSc99 = AvReSc99[NewsID !=6] 
  Sents    = Sents[NewsID !=6]
  ThTaID   = ThTaID[NewsID !=6]
  Page1    = Page1[NewsID !=6]
  CIdeo    = CIdeo[NewsID !=6]
  Party    = Party[NewsID !=6]
  Critic   = Critic[NewsID !=6] 
  Label    = Label[NewsID !=6]
  NewsID   = NewsID[NewsID !=6]
  for (j in 6:21){ 
    NewsID = ifelse(NewsID==j,j-1,NewsID) 
  } 
}

if (OmitCNN) {
  print("Omitting CNN ID=5")
 
  outlet = 5
  
  NumDate  = NumDate[NewsID !=outlet] 
  AvReSc99 = AvReSc99[NewsID !=outlet] 
  Sents    = Sents[NewsID !=outlet]
  ThTaID   = ThTaID[NewsID !=outlet]
  Page1    = Page1[NewsID !=outlet]
  CIdeo    = CIdeo[NewsID !=outlet]
  Party    = Party[NewsID !=outlet]
  Critic   = Critic[NewsID !=outlet] 
  Label    = Label[NewsID !=outlet]
  NewsID   = NewsID[NewsID !=outlet]
  for (j in (outlet+1):21){ 
    NewsID = ifelse(NewsID==j,j-1,NewsID) 
  } 
}
if (OmitCBS) {
  print("Omitting CBS ID=4")
 
  outlet = 4
  
  NumDate  = NumDate[NewsID !=outlet] 
  AvReSc99 = AvReSc99[NewsID !=outlet] 
  Sents    = Sents[NewsID !=outlet]
  ThTaID   = ThTaID[NewsID !=outlet]
  Page1    = Page1[NewsID !=outlet]
  CIdeo    = CIdeo[NewsID !=outlet]
  Party    = Party[NewsID !=outlet]
  Critic   = Critic[NewsID !=outlet] 
  Label    = Label[NewsID !=outlet]
  NewsID   = NewsID[NewsID !=outlet]
  for (j in (outlet+1):21){ 
    NewsID = ifelse(NewsID==j,j-1,NewsID) 
  } 
}

if (OmitCBSEarly) {
  print("Omitting CBS Early ID=3")
 
  outlet = 3
  
  NumDate  = NumDate[NewsID !=outlet] 
  AvReSc99 = AvReSc99[NewsID !=outlet] 
  Sents    = Sents[NewsID !=outlet]
  ThTaID   = ThTaID[NewsID !=outlet]
  Page1    = Page1[NewsID !=outlet]
  CIdeo    = CIdeo[NewsID !=outlet]
  Party    = Party[NewsID !=outlet]
  Critic   = Critic[NewsID !=outlet] 
  Label    = Label[NewsID !=outlet]
  NewsID   = NewsID[NewsID !=outlet]
  for (j in (outlet+1):21){ 
    NewsID = ifelse(NewsID==j,j-1,NewsID) 
  } 
}

if (OmitABC) {
  print("Omitting ABC World News ID=2")
 
  outlet = 2
  
  NumDate  = NumDate[NewsID !=outlet] 
  AvReSc99 = AvReSc99[NewsID !=outlet] 
  Sents    = Sents[NewsID !=outlet]
  ThTaID   = ThTaID[NewsID !=outlet]
  Page1    = Page1[NewsID !=outlet]
  CIdeo    = CIdeo[NewsID !=outlet]
  Party    = Party[NewsID !=outlet]
  Critic   = Critic[NewsID !=outlet] 
  Label    = Label[NewsID !=outlet]
  NewsID   = NewsID[NewsID !=outlet]
  for (j in (outlet+1):21){ 
    NewsID = ifelse(NewsID==j,j-1,NewsID) 
  } 
}
if (OmitABCMorning) {
  print("Omitting ABC Morning  ID=1")
 
  outlet = 1
  
  NumDate  = NumDate[NewsID !=outlet] 
  AvReSc99 = AvReSc99[NewsID !=outlet] 
  Sents    = Sents[NewsID !=outlet]
  ThTaID   = ThTaID[NewsID !=outlet]
  Page1    = Page1[NewsID !=outlet]
  CIdeo    = CIdeo[NewsID !=outlet]
  Party    = Party[NewsID !=outlet]
  Critic   = Critic[NewsID !=outlet] 
  Label    = Label[NewsID !=outlet]
  NewsID   = NewsID[NewsID !=outlet]
  for (j in (outlet+1):21){ 
    NewsID = ifelse(NewsID==j,j-1,NewsID) 
  } 
}



# Create a Gore-coder-NBCnn and a Bush-NBCnn 
#if (OmitNBC2 == F){ 
#  NewsID = ifelse(NewsID ==8 & CIdeo == 0,22,NewsID) 
#  NewsID = ifelse(NewsID ==9 & CIdeo == 0,22,NewsID) 
#  NewsID = ifelse(NewsID ==8 & CIdeo == 1,9,NewsID) 
#  NewsID = ifelse(NewsID ==22 & CIdeo == 0,8,NewsID) 
#} 
 
# To use both NBCnn sets of data, while constraining them to the same score 
# NewsID = ifelse(NewsID >8, (NewsID-1), NewsID) 
 
if (OmitACLU) { 
  NumDate  = NumDate[ThTaID !=7] 
  AvReSc99 = AvReSc99[ThTaID !=7] 
  Sents    = Sents[ThTaID !=7] 
  Page1    = Page1[ThTaID !=7] 
  CIdeo    = CIdeo[ThTaID !=7] 
  Party    = Party[ThTaID !=7] 
  Critic   = Critic[ThTaID !=7]  
  Label    = Label[ThTaID !=7] 
  NewsID   = NewsID[ThTaID !=7] 
  ThTaID   = ThTaID[ThTaID !=7] 
  ttN      = max(ThTaID) 
  for (j in 8:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  } 
} 



###ThinkTanks  2 3 16 28 33 57 64 66 69 72 76 77 78 87 88 89 92 95 105
#              108 109 118 120 124 130 133 140 145 147 148 154 162 163
#              165 166 have zero obs
#this causes a problem w/ the mle. the follow code drops the obs

if (OmitTT0004) {
  #drops TT2
  NumDate  = NumDate[ThTaID !=2] 
  AvReSc99 = AvReSc99[ThTaID !=2] 
  Sents    = Sents[ThTaID !=2] 
  Page1    = Page1[ThTaID !=2] 
  CIdeo    = CIdeo[ThTaID !=2] 
  Party    = Party[ThTaID !=2] 
  Critic   = Critic[ThTaID !=2]  
  Label    = Label[ThTaID !=2] 
  NewsID   = NewsID[ThTaID !=2] 
  ThTaID   = ThTaID[ThTaID !=2] 
  ttN      = max(ThTaID) 
  for (j in 3:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }

  
  #drops TT3
  NumDate  = NumDate[ThTaID !=2] 
  AvReSc99 = AvReSc99[ThTaID !=2] 
  Sents    = Sents[ThTaID !=2] 
  Page1    = Page1[ThTaID !=2] 
  CIdeo    = CIdeo[ThTaID !=2] 
  Party    = Party[ThTaID !=2] 
  Critic   = Critic[ThTaID !=2]  
  Label    = Label[ThTaID !=2] 
  NewsID   = NewsID[ThTaID !=2] 
  ThTaID   = ThTaID[ThTaID !=2] 
  ttN      = max(ThTaID) 
  for (j in 3:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }

    
  #drops TT16
  NumDate  = NumDate[ThTaID !=14] 
  AvReSc99 = AvReSc99[ThTaID !=14] 
  Sents    = Sents[ThTaID !=14] 
  Page1    = Page1[ThTaID !=14] 
  CIdeo    = CIdeo[ThTaID !=14] 
  Party    = Party[ThTaID !=14] 
  Critic   = Critic[ThTaID !=14]  
  Label    = Label[ThTaID !=14] 
  NewsID   = NewsID[ThTaID !=14] 
  ThTaID   = ThTaID[ThTaID !=14] 
  ttN      = max(ThTaID) 
  for (j in 15:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }
  
  #drops TT28
  NumDate  = NumDate[ThTaID !=25] 
  AvReSc99 = AvReSc99[ThTaID !=25] 
  Sents    = Sents[ThTaID !=25] 
  Page1    = Page1[ThTaID !=25] 
  CIdeo    = CIdeo[ThTaID !=25] 
  Party    = Party[ThTaID !=25] 
  Critic   = Critic[ThTaID !=25]  
  Label    = Label[ThTaID !=25] 
  NewsID   = NewsID[ThTaID !=25] 
  ThTaID   = ThTaID[ThTaID !=25] 
  ttN      = max(ThTaID) 
  for (j in 26:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }


  
    
  #drops TT33
  NumDate  = NumDate[ThTaID !=29] 
  AvReSc99 = AvReSc99[ThTaID !=29] 
  Sents    = Sents[ThTaID !=29] 
  Page1    = Page1[ThTaID !=29] 
  CIdeo    = CIdeo[ThTaID !=29] 
  Party    = Party[ThTaID !=29] 
  Critic   = Critic[ThTaID !=29]  
  Label    = Label[ThTaID !=29] 
  NewsID   = NewsID[ThTaID !=29] 
  ThTaID   = ThTaID[ThTaID !=29] 
  ttN      = max(ThTaID) 
  for (j in 30:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }



    
  #drops TT57
  NumDate  = NumDate[ThTaID !=52] 
  AvReSc99 = AvReSc99[ThTaID !=52] 
  Sents    = Sents[ThTaID !=52] 
  Page1    = Page1[ThTaID !=52] 
  CIdeo    = CIdeo[ThTaID !=52] 
  Party    = Party[ThTaID !=52] 
  Critic   = Critic[ThTaID !=52]  
  Label    = Label[ThTaID !=52] 
  NewsID   = NewsID[ThTaID !=52] 
  ThTaID   = ThTaID[ThTaID !=52] 
  ttN      = max(ThTaID) 
  for (j in 53:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }



  
  #drops TT64
  NumDate  = NumDate[ThTaID !=58] 
  AvReSc99 = AvReSc99[ThTaID !=58] 
  Sents    = Sents[ThTaID !=58] 
  Page1    = Page1[ThTaID !=58] 
  CIdeo    = CIdeo[ThTaID !=58] 
  Party    = Party[ThTaID !=58] 
  Critic   = Critic[ThTaID !=58]  
  Label    = Label[ThTaID !=58] 
  NewsID   = NewsID[ThTaID !=58] 
  ThTaID   = ThTaID[ThTaID !=58] 
  ttN      = max(ThTaID) 
  for (j in 59:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }

  
  #drops TT66
  NumDate  = NumDate[ThTaID !=59] 
  AvReSc99 = AvReSc99[ThTaID !=59] 
  Sents    = Sents[ThTaID !=59] 
  Page1    = Page1[ThTaID !=59] 
  CIdeo    = CIdeo[ThTaID !=59] 
  Party    = Party[ThTaID !=59] 
  Critic   = Critic[ThTaID !=59]  
  Label    = Label[ThTaID !=59] 
  NewsID   = NewsID[ThTaID !=59] 
  ThTaID   = ThTaID[ThTaID !=59] 
  ttN      = max(ThTaID) 
  for (j in 60:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }


    
  #drops TT69
  NumDate  = NumDate[ThTaID !=61] 
  AvReSc99 = AvReSc99[ThTaID !=61] 
  Sents    = Sents[ThTaID !=61] 
  Page1    = Page1[ThTaID !=61] 
  CIdeo    = CIdeo[ThTaID !=61] 
  Party    = Party[ThTaID !=61] 
  Critic   = Critic[ThTaID !=61]  
  Label    = Label[ThTaID !=61] 
  NewsID   = NewsID[ThTaID !=61] 
  ThTaID   = ThTaID[ThTaID !=61] 
  ttN      = max(ThTaID) 
  for (j in 62:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }


  
  #drops TT72
  NumDate  = NumDate[ThTaID !=63] 
  AvReSc99 = AvReSc99[ThTaID !=63] 
  Sents    = Sents[ThTaID !=63] 
  Page1    = Page1[ThTaID !=63] 
  CIdeo    = CIdeo[ThTaID !=63] 
  Party    = Party[ThTaID !=63] 
  Critic   = Critic[ThTaID !=63]  
  Label    = Label[ThTaID !=63] 
  NewsID   = NewsID[ThTaID !=63] 
  ThTaID   = ThTaID[ThTaID !=63] 
  ttN      = max(ThTaID) 
  for (j in 64:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }

 #drops TT76
  NumDate  = NumDate[ThTaID !=66] 
  AvReSc99 = AvReSc99[ThTaID !=66] 
  Sents    = Sents[ThTaID !=66] 
  Page1    = Page1[ThTaID !=66] 
  CIdeo    = CIdeo[ThTaID !=66] 
  Party    = Party[ThTaID !=66] 
  Critic   = Critic[ThTaID !=66]  
  Label    = Label[ThTaID !=66] 
  NewsID   = NewsID[ThTaID !=66] 
  ThTaID   = ThTaID[ThTaID !=66] 
  ttN      = max(ThTaID) 
  for (j in 67:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }

 #drops TT77
  NumDate  = NumDate[ThTaID !=66] 
  AvReSc99 = AvReSc99[ThTaID !=66] 
  Sents    = Sents[ThTaID !=66] 
  Page1    = Page1[ThTaID !=66] 
  CIdeo    = CIdeo[ThTaID !=66] 
  Party    = Party[ThTaID !=66] 
  Critic   = Critic[ThTaID !=66]  
  Label    = Label[ThTaID !=66] 
  NewsID   = NewsID[ThTaID !=66] 
  ThTaID   = ThTaID[ThTaID !=66] 
  ttN      = max(ThTaID) 
  for (j in 67:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }

  
 #drops TT78
  NumDate  = NumDate[ThTaID !=66] 
  AvReSc99 = AvReSc99[ThTaID !=66] 
  Sents    = Sents[ThTaID !=66] 
  Page1    = Page1[ThTaID !=66] 
  CIdeo    = CIdeo[ThTaID !=66] 
  Party    = Party[ThTaID !=66] 
  Critic   = Critic[ThTaID !=66]  
  Label    = Label[ThTaID !=66] 
  NewsID   = NewsID[ThTaID !=66] 
  ThTaID   = ThTaID[ThTaID !=66] 
  ttN      = max(ThTaID) 
  for (j in 67:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }
  

 #drops TT87
  NumDate  = NumDate[ThTaID !=74] 
  AvReSc99 = AvReSc99[ThTaID !=74] 
  Sents    = Sents[ThTaID !=74] 
  Page1    = Page1[ThTaID !=74] 
  CIdeo    = CIdeo[ThTaID !=74] 
  Party    = Party[ThTaID !=74] 
  Critic   = Critic[ThTaID !=74]  
  Label    = Label[ThTaID !=74] 
  NewsID   = NewsID[ThTaID !=74] 
  ThTaID   = ThTaID[ThTaID !=74] 
  ttN      = max(ThTaID) 
  for (j in 75:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }


 #drops TT88
  NumDate  = NumDate[ThTaID !=74] 
  AvReSc99 = AvReSc99[ThTaID !=74] 
  Sents    = Sents[ThTaID !=74] 
  Page1    = Page1[ThTaID !=74] 
  CIdeo    = CIdeo[ThTaID !=74] 
  Party    = Party[ThTaID !=74] 
  Critic   = Critic[ThTaID !=74]  
  Label    = Label[ThTaID !=74] 
  NewsID   = NewsID[ThTaID !=74] 
  ThTaID   = ThTaID[ThTaID !=74] 
  ttN      = max(ThTaID) 
  for (j in 75:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }

  
 #drops TT89
  NumDate  = NumDate[ThTaID !=74] 
  AvReSc99 = AvReSc99[ThTaID !=74] 
  Sents    = Sents[ThTaID !=74] 
  Page1    = Page1[ThTaID !=74] 
  CIdeo    = CIdeo[ThTaID !=74] 
  Party    = Party[ThTaID !=74] 
  Critic   = Critic[ThTaID !=74]  
  Label    = Label[ThTaID !=74] 
  NewsID   = NewsID[ThTaID !=74] 
  ThTaID   = ThTaID[ThTaID !=74] 
  ttN      = max(ThTaID) 
  for (j in 75:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }

  
 #drops TT92
  NumDate  = NumDate[ThTaID !=76] 
  AvReSc99 = AvReSc99[ThTaID !=76] 
  Sents    = Sents[ThTaID !=76] 
  Page1    = Page1[ThTaID !=76] 
  CIdeo    = CIdeo[ThTaID !=76] 
  Party    = Party[ThTaID !=76] 
  Critic   = Critic[ThTaID !=76]  
  Label    = Label[ThTaID !=76] 
  NewsID   = NewsID[ThTaID !=76] 
  ThTaID   = ThTaID[ThTaID !=76] 
  ttN      = max(ThTaID) 
  for (j in 77:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }

  
 #drops TT95
  NumDate  = NumDate[ThTaID !=78] 
  AvReSc99 = AvReSc99[ThTaID !=78] 
  Sents    = Sents[ThTaID !=78] 
  Page1    = Page1[ThTaID !=78] 
  CIdeo    = CIdeo[ThTaID !=78] 
  Party    = Party[ThTaID !=78] 
  Critic   = Critic[ThTaID !=78]  
  Label    = Label[ThTaID !=78] 
  NewsID   = NewsID[ThTaID !=78] 
  ThTaID   = ThTaID[ThTaID !=78] 
  ttN      = max(ThTaID) 
  for (j in 79:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }

  
 #drops TT105
  NumDate  = NumDate[ThTaID !=87] 
  AvReSc99 = AvReSc99[ThTaID !=87] 
  Sents    = Sents[ThTaID !=87] 
  Page1    = Page1[ThTaID !=87] 
  CIdeo    = CIdeo[ThTaID !=87] 
  Party    = Party[ThTaID !=87] 
  Critic   = Critic[ThTaID !=87]  
  Label    = Label[ThTaID !=87] 
  NewsID   = NewsID[ThTaID !=87] 
  ThTaID   = ThTaID[ThTaID !=87] 
  ttN      = max(ThTaID) 
  for (j in 88:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }


  
 #drops TT108
  NumDate  = NumDate[ThTaID !=89] 
  AvReSc99 = AvReSc99[ThTaID !=89] 
  Sents    = Sents[ThTaID !=89] 
  Page1    = Page1[ThTaID !=89] 
  CIdeo    = CIdeo[ThTaID !=89] 
  Party    = Party[ThTaID !=89] 
  Critic   = Critic[ThTaID !=89]  
  Label    = Label[ThTaID !=89] 
  NewsID   = NewsID[ThTaID !=89] 
  ThTaID   = ThTaID[ThTaID !=89] 
  ttN      = max(ThTaID) 
  for (j in 90:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }


 #drops TT109
  NumDate  = NumDate[ThTaID !=89] 
  AvReSc99 = AvReSc99[ThTaID !=89] 
  Sents    = Sents[ThTaID !=89] 
  Page1    = Page1[ThTaID !=89] 
  CIdeo    = CIdeo[ThTaID !=89] 
  Party    = Party[ThTaID !=89] 
  Critic   = Critic[ThTaID !=89]  
  Label    = Label[ThTaID !=89] 
  NewsID   = NewsID[ThTaID !=89] 
  ThTaID   = ThTaID[ThTaID !=89] 
  ttN      = max(ThTaID) 
  for (j in 90:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }

  
  
 #drops TT118
  NumDate  = NumDate[ThTaID !=97] 
  AvReSc99 = AvReSc99[ThTaID !=97] 
  Sents    = Sents[ThTaID !=97] 
  Page1    = Page1[ThTaID !=97] 
  CIdeo    = CIdeo[ThTaID !=97] 
  Party    = Party[ThTaID !=97] 
  Critic   = Critic[ThTaID !=97]  
  Label    = Label[ThTaID !=97] 
  NewsID   = NewsID[ThTaID !=97] 
  ThTaID   = ThTaID[ThTaID !=97] 
  ttN      = max(ThTaID) 
  for (j in 98:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }
  
  
 #drops TT120
  NumDate  = NumDate[ThTaID !=98] 
  AvReSc99 = AvReSc99[ThTaID !=98] 
  Sents    = Sents[ThTaID !=98] 
  Page1    = Page1[ThTaID !=98] 
  CIdeo    = CIdeo[ThTaID !=98] 
  Party    = Party[ThTaID !=98] 
  Critic   = Critic[ThTaID !=98]  
  Label    = Label[ThTaID !=98] 
  NewsID   = NewsID[ThTaID !=98] 
  ThTaID   = ThTaID[ThTaID !=98] 
  ttN      = max(ThTaID) 
  for (j in 99:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }
  

  

   #drops TT124
  NumDate  = NumDate[ThTaID !=101] 
  AvReSc99 = AvReSc99[ThTaID !=101] 
  Sents    = Sents[ThTaID !=101] 
  Page1    = Page1[ThTaID !=101] 
  CIdeo    = CIdeo[ThTaID !=101] 
  Party    = Party[ThTaID !=101] 
  Critic   = Critic[ThTaID !=101]  
  Label    = Label[ThTaID !=101] 
  NewsID   = NewsID[ThTaID !=101] 
  ThTaID   = ThTaID[ThTaID !=101] 
  ttN      = max(ThTaID) 
  for (j in 101:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }

 #drops TT130
  NumDate  = NumDate[ThTaID !=106] 
  AvReSc99 = AvReSc99[ThTaID !=106] 
  Sents    = Sents[ThTaID !=106] 
  Page1    = Page1[ThTaID !=106] 
  CIdeo    = CIdeo[ThTaID !=106] 
  Party    = Party[ThTaID !=106] 
  Critic   = Critic[ThTaID !=106]  
  Label    = Label[ThTaID !=106] 
  NewsID   = NewsID[ThTaID !=106] 
  ThTaID   = ThTaID[ThTaID !=106] 
  ttN      = max(ThTaID) 
  for (j in 107:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }


   #drops TT133
  NumDate  = NumDate[ThTaID !=108] 
  AvReSc99 = AvReSc99[ThTaID !=108] 
  Sents    = Sents[ThTaID !=108] 
  Page1    = Page1[ThTaID !=108] 
  CIdeo    = CIdeo[ThTaID !=108] 
  Party    = Party[ThTaID !=108] 
  Critic   = Critic[ThTaID !=108]  
  Label    = Label[ThTaID !=108] 
  NewsID   = NewsID[ThTaID !=108] 
  ThTaID   = ThTaID[ThTaID !=108] 
  ttN      = max(ThTaID) 
  for (j in 109:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }

  
 #drops TT140
  NumDate  = NumDate[ThTaID !=114] 
  AvReSc99 = AvReSc99[ThTaID !=114] 
  Sents    = Sents[ThTaID !=114] 
  Page1    = Page1[ThTaID !=114] 
  CIdeo    = CIdeo[ThTaID !=114] 
  Party    = Party[ThTaID !=114] 
  Critic   = Critic[ThTaID !=114]  
  Label    = Label[ThTaID !=114] 
  NewsID   = NewsID[ThTaID !=114] 
  ThTaID   = ThTaID[ThTaID !=114] 
  ttN      = max(ThTaID) 
  for (j in 115:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }


  #drops TT145
  NumDate  = NumDate[ThTaID !=118] 
  AvReSc99 = AvReSc99[ThTaID !=118] 
  Sents    = Sents[ThTaID !=118] 
  Page1    = Page1[ThTaID !=118] 
  CIdeo    = CIdeo[ThTaID !=118] 
  Party    = Party[ThTaID !=118] 
  Critic   = Critic[ThTaID !=118]  
  Label    = Label[ThTaID !=118] 
  NewsID   = NewsID[ThTaID !=118] 
  ThTaID   = ThTaID[ThTaID !=118] 
  ttN      = max(ThTaID) 
  for (j in 119:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }

   #drops TT147
  NumDate  = NumDate[ThTaID !=119] 
  AvReSc99 = AvReSc99[ThTaID !=119] 
  Sents    = Sents[ThTaID !=119] 
  Page1    = Page1[ThTaID !=119] 
  CIdeo    = CIdeo[ThTaID !=119] 
  Party    = Party[ThTaID !=119] 
  Critic   = Critic[ThTaID !=119]  
  Label    = Label[ThTaID !=119] 
  NewsID   = NewsID[ThTaID !=119] 
  ThTaID   = ThTaID[ThTaID !=119] 
  ttN      = max(ThTaID) 
  for (j in 120:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }

   #drops TT147
  NumDate  = NumDate[ThTaID !=119] 
  AvReSc99 = AvReSc99[ThTaID !=119] 
  Sents    = Sents[ThTaID !=119] 
  Page1    = Page1[ThTaID !=119] 
  CIdeo    = CIdeo[ThTaID !=119] 
  Party    = Party[ThTaID !=119] 
  Critic   = Critic[ThTaID !=119]  
  Label    = Label[ThTaID !=119] 
  NewsID   = NewsID[ThTaID !=119] 
  ThTaID   = ThTaID[ThTaID !=119] 
  ttN      = max(ThTaID) 
  for (j in 120:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }


  
   #drops TT154
  NumDate  = NumDate[ThTaID !=124] 
  AvReSc99 = AvReSc99[ThTaID !=124] 
  Sents    = Sents[ThTaID !=124] 
  Page1    = Page1[ThTaID !=124] 
  CIdeo    = CIdeo[ThTaID !=124] 
  Party    = Party[ThTaID !=124] 
  Critic   = Critic[ThTaID !=124]  
  Label    = Label[ThTaID !=124] 
  NewsID   = NewsID[ThTaID !=124] 
  ThTaID   = ThTaID[ThTaID !=124] 
  ttN      = max(ThTaID) 
  for (j in 125:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }


  #drops TT162
  NumDate  = NumDate[ThTaID !=131] 
  AvReSc99 = AvReSc99[ThTaID !=131] 
  Sents    = Sents[ThTaID !=131] 
  Page1    = Page1[ThTaID !=131] 
  CIdeo    = CIdeo[ThTaID !=131] 
  Party    = Party[ThTaID !=131] 
  Critic   = Critic[ThTaID !=131]  
  Label    = Label[ThTaID !=131] 
  NewsID   = NewsID[ThTaID !=131] 
  ThTaID   = ThTaID[ThTaID !=131] 
  ttN      = max(ThTaID) 
  for (j in 132:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }


  #drops TT163
  NumDate  = NumDate[ThTaID !=131] 
  AvReSc99 = AvReSc99[ThTaID !=131] 
  Sents    = Sents[ThTaID !=131] 
  Page1    = Page1[ThTaID !=131] 
  CIdeo    = CIdeo[ThTaID !=131] 
  Party    = Party[ThTaID !=131] 
  Critic   = Critic[ThTaID !=131]  
  Label    = Label[ThTaID !=131] 
  NewsID   = NewsID[ThTaID !=131] 
  ThTaID   = ThTaID[ThTaID !=131] 
  ttN      = max(ThTaID) 
  for (j in 132:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }
  

  #drops TT165
  NumDate  = NumDate[ThTaID !=132] 
  AvReSc99 = AvReSc99[ThTaID !=132] 
  Sents    = Sents[ThTaID !=132] 
  Page1    = Page1[ThTaID !=132] 
  CIdeo    = CIdeo[ThTaID !=132] 
  Party    = Party[ThTaID !=132] 
  Critic   = Critic[ThTaID !=132]  
  Label    = Label[ThTaID !=132] 
  NewsID   = NewsID[ThTaID !=132] 
  ThTaID   = ThTaID[ThTaID !=132] 
  ttN      = max(ThTaID) 
  for (j in 133:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }
  
  #drops TT166
  NumDate  = NumDate[ThTaID !=132] 
  AvReSc99 = AvReSc99[ThTaID !=132] 
  Sents    = Sents[ThTaID !=132] 
  Page1    = Page1[ThTaID !=132] 
  CIdeo    = CIdeo[ThTaID !=132] 
  Party    = Party[ThTaID !=132] 
  Critic   = Critic[ThTaID !=132]  
  Label    = Label[ThTaID !=132] 
  NewsID   = NewsID[ThTaID !=132] 
  ThTaID   = ThTaID[ThTaID !=132] 
  ttN      = max(ThTaID) 
  for (j in 133:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }
  
  
}




###ThinkTanks 19 31 37 42 43 107 117 142 have zero obs
#this causes a problem w/ the mle. the follow code drops the obs

if (OmitTT9099) {
  #drops TT19:California Institute for Rural Studies
  NumDate  = NumDate[ThTaID !=19] 
  AvReSc99 = AvReSc99[ThTaID !=19] 
  Sents    = Sents[ThTaID !=19] 
  Page1    = Page1[ThTaID !=19] 
  CIdeo    = CIdeo[ThTaID !=19] 
  Party    = Party[ThTaID !=19] 
  Critic   = Critic[ThTaID !=19]  
  Label    = Label[ThTaID !=19] 
  NewsID   = NewsID[ThTaID !=19] 
  ThTaID   = ThTaID[ThTaID !=19] 
  ttN      = max(ThTaID) 
  for (j in 20:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }


    #drops TT31:Center for Nonproliferation Studies (ttid=30)
  NumDate  = NumDate[ThTaID !=30] 
  AvReSc99 = AvReSc99[ThTaID !=30] 
  Sents    = Sents[ThTaID !=30] 
  Page1    = Page1[ThTaID !=30] 
  CIdeo    = CIdeo[ThTaID !=30] 
  Party    = Party[ThTaID !=30] 
  Critic   = Critic[ThTaID !=30]  
  Label    = Label[ThTaID !=30] 
  NewsID   = NewsID[ThTaID !=30] 
  ThTaID   = ThTaID[ThTaID !=30] 
  ttN      = max(ThTaID) 
  for (j in 31:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }

  
    #drops TT37:Center for Strategic and Budgetary Assessments(ttid=35)
  NumDate  = NumDate[ThTaID !=35] 
  AvReSc99 = AvReSc99[ThTaID !=35] 
  Sents    = Sents[ThTaID !=35] 
  Page1    = Page1[ThTaID !=35] 
  CIdeo    = CIdeo[ThTaID !=35] 
  Party    = Party[ThTaID !=35] 
  Critic   = Critic[ThTaID !=35]  
  Label    = Label[ThTaID !=35] 
  NewsID   = NewsID[ThTaID !=35] 
  ThTaID   = ThTaID[ThTaID !=35] 
  ttN      = max(ThTaID) 
  for (j in 36:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }


      #drops TT42:Center for the Study of the Presidency (ttid=39)
  NumDate  = NumDate[ThTaID !=39] 
  AvReSc99 = AvReSc99[ThTaID !=39] 
  Sents    = Sents[ThTaID !=39] 
  Page1    = Page1[ThTaID !=39] 
  CIdeo    = CIdeo[ThTaID !=39] 
  Party    = Party[ThTaID !=39] 
  Critic   = Critic[ThTaID !=39]  
  Label    = Label[ThTaID !=39] 
  NewsID   = NewsID[ThTaID !=39] 
  ThTaID   = ThTaID[ThTaID !=39] 
  ttN      = max(ThTaID) 
  for (j in 40:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }

      #drops TT43:Center of the American Experiment  (ttid=39)
  NumDate  = NumDate[ThTaID !=39] 
  AvReSc99 = AvReSc99[ThTaID !=39] 
  Sents    = Sents[ThTaID !=39] 
  Page1    = Page1[ThTaID !=39] 
  CIdeo    = CIdeo[ThTaID !=39] 
  Party    = Party[ThTaID !=39] 
  Critic   = Critic[ThTaID !=39]  
  Label    = Label[ThTaID !=39] 
  NewsID   = NewsID[ThTaID !=39] 
  ThTaID   = ThTaID[ThTaID !=39] 
  ttN      = max(ThTaID) 
  for (j in 40:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }

  #drops TT107:International Policy Institute for Counter-Terrorism (ttid=102)
  NumDate  = NumDate[ThTaID !=102] 
  AvReSc99 = AvReSc99[ThTaID !=102] 
  Sents    = Sents[ThTaID !=102] 
  Page1    = Page1[ThTaID !=102] 
  CIdeo    = CIdeo[ThTaID !=102] 
  Party    = Party[ThTaID !=102] 
  Critic   = Critic[ThTaID !=102]  
  Label    = Label[ThTaID !=102] 
  NewsID   = NewsID[ThTaID !=102] 
  ThTaID   = ThTaID[ThTaID !=102] 
  ttN      = max(ThTaID) 
  for (j in 103:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }


    #drops TT117:  Massachusetts Institute for a New Commonwealth (ttid=111)
  NumDate  = NumDate[ThTaID !=111] 
  AvReSc99 = AvReSc99[ThTaID !=111] 
  Sents    = Sents[ThTaID !=111] 
  Page1    = Page1[ThTaID !=111] 
  CIdeo    = CIdeo[ThTaID !=111] 
  Party    = Party[ThTaID !=111] 
  Critic   = Critic[ThTaID !=111]  
  Label    = Label[ThTaID !=111] 
  NewsID   = NewsID[ThTaID !=111] 
  ThTaID   = ThTaID[ThTaID !=111] 
  ttN      = max(ThTaID) 
  for (j in 112:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }

    #drops TT142:  Oklahoma Council of Public Affairs (ttid=135)
  NumDate  = NumDate[ThTaID !=135] 
  AvReSc99 = AvReSc99[ThTaID !=135] 
  Sents    = Sents[ThTaID !=135] 
  Page1    = Page1[ThTaID !=135] 
  CIdeo    = CIdeo[ThTaID !=135] 
  Party    = Party[ThTaID !=135] 
  Critic   = Critic[ThTaID !=135]  
  Label    = Label[ThTaID !=135] 
  NewsID   = NewsID[ThTaID !=135] 
  ThTaID   = ThTaID[ThTaID !=135] 
  ttN      = max(ThTaID) 
  for (j in 136:ttN){ 
    ThTaID = ifelse(ThTaID==j,j-1,ThTaID) 
  }
  
} 





### Use the following to test NYT = Wash. Post 
#NewsID = ifelse(NewsID==11, 2, NewsID) 
#NewsID = ifelse(NewsID >11, (NewsID-1), NewsID) 
 
###### Caclulate Total number of Obs and total number of th tanks. ### 
TotalObs     = length(NewsID) 
ttN          = max(ThTaID) 
TotalOutlets = max(NewsID) 
 
 
####### Compute Ave. Sco. of legislators citing th. tank j ############ 
  
#for (j in 1:ttN) { 
#  cong.cite.true = ifelse(xx$NewsID ==0 & xx$ThTaID == j,1,0) 
#  cong.cite.sc <- ifelse(xx$NewsID ==0 & xx$ThTaID == j,xx$AvReSc99,0) 
#  ttav[j]=sum(cong.cite.sc)/sum(cong.cite.true) 
#} 
 
getav = function(j){ 
  cong.cite.true = ifelse(NewsID ==0 & ThTaID == j,1,0) 
  cong.cite.sc <- ifelse(NewsID ==0 & ThTaID == j,AvReSc99,0) 
 # ttavTem=sum(cong.cite.sc)/sum(cong.cite.true)
  
  ttavTem = ifelse(sum(cong.cite.sc)==0, 0, sum(cong.cite.sc)/sum(cong.cite.true))
  ttavTem 
} 
 
pp = 1:ttN 
ttav = sapply(pp, getav) 
 
####### Compute number of cites by legislators to th tank j ############# 
 
getcongcites = function(j){ 
  cong.cite.true = ifelse(NewsID ==0 & ThTaID == j,1,0) 
  ttcitesTem=sum(cong.cite.true) 
  ttcitesTem 
} 
 
pp = 1:ttN 
ttcongcites = sapply(pp, getcongcites) 
 
 
####### Compute number of cites by media to th tank j ############# 
 
getmediacites = function(j){ 
  med.cite.true = ifelse(NewsID !=0  & ThTaID == j,1,0) 
  ttcitesTem=sum(med.cite.true) 
  ttcitesTem 
} 
 
pp = 1:ttN 
ttmedcites = sapply(pp, getmediacites) 
 
 
################# Print data for Table 1  ########################### 
 
## Set OmitCrits, OmitLabels to T.  Set OmitACLU to F 
 
print("Think Tank ID, Ave. Sco of legislator citing it, Cong Cites,  Media Cites") 
print(cbind(1:ttN,ttav,ttcongcites,ttmedcites)) 
 
 
 
############# Compute Back of the Envelope Estimates  ################ 
 
## Create a vector that indicates if th tank is liberal   
LibThTa = rep(0,TotalObs) 
for (j in 1:ttN) { 
  LibThTa = ifelse(ThTaID == j & ttav[j] > CutPoint, 1, LibThTa) 
} 
 
## Create vectors that indicate if obs is by a Dem or Repub legislator 
Dem = ifelse(NewsID==0 & Party == 1,1,0) 
Rep = ifelse(NewsID==0 & Party == 2,1,0) 
Cong = ifelse(NewsID==0,1,0) 
 
## Creat vectors that indicate if obs is, e.g., a Dem citing a lib th tank 
DemCiteLib = ifelse(NewsID==0 & Party == 1 & LibThTa == 1,1,0) 
RepCiteLib = ifelse(NewsID==0 & Party == 2 & LibThTa == 1,1,0) 
CongCiteLib = ifelse(NewsID==0 & LibThTa == 1,1,0) 
 
## Create scalar = fraction of time that Dems cite lib th tanks 
DemFrac  = sum(DemCiteLib)/sum(Dem) 
RepFrac  = sum(RepCiteLib)/sum(Rep) 
CongFrac = sum(CongCiteLib)/sum(Cong) 
 
 
TotOutlets = max(NewsID) 
MedFrac = rep(0,TotOutlets) 
 
for (j in 1:TotOutlets){ 
  MedCiteTrue = ifelse(NewsID == j,1,0) 
  MedCiteLib  = ifelse(NewsID == j & LibThTa == 1,1,0) 
  MedFrac[j] = sum(MedCiteLib)/sum(MedCiteTrue) 
} 
   
 
## Create vector of Democratic Real scores. = 0 if not Dem (or a News Oulet) 
DemScores  = ifelse(NewsID==0 & Party == 1,AvReSc99,0) 
RepScores  = ifelse(NewsID==0 & Party == 2,AvReSc99,0) 
CongScores = ifelse(NewsID==0,AvReSc99,0) 
 
 
DemAve = sum(DemScores)/sum(Dem) 
RepAve = sum(RepScores)/sum(Rep) 
CongAve = sum(CongScores)/sum(Cong) 
 
BOTE.Score = rep(0,TotOutlets) 
for (j in 1:TotOutlets){ 
  BOTE.Score[j] = RepAve+(DemAve-RepAve)*(MedFrac[j]-RepFrac)/(DemFrac-RepFrac) 
} 
 
################### Print Descriptive Stats  ############################## 
 
print("News Outlet ID, Frac of cites to lib th tanks, BOTE ADA score") 
print(cbind(MedFrac,BOTE.Score)) 
 
print("Ave Scores of Repubs, Dems, and All members of Congress") 
print(cbind(RepAve,CongAve,DemAve)) 
 
print("Frac of cites to lib th tanks by Repubs, Dems, and All members of Congress") 
print(cbind(RepFrac,CongFrac,DemFrac)) 
 
print("Of all citations to all think tanks in Congress, Repubs had the following fraction") 
RepFloorTime = sum(Rep)/sum(Cong) 
print(RepFloorTime) 
 
 
 
################################################################################ 
########################  Create NewThTaID ##################################### 
################################################################################ 
 
# 1 = Heritage, 2 = the most-cited think tank by the media 
# ActualThTaN = the think tank ranked ActualThaN in terms of  
# cites by the media.  ActualThTaN + 1 = the most right-wing 
# mega think tank. 
 
######### Create NewList and NewCites -- vectors of length ttN  ################ 
 
NewCites    = rep(-1,ttN) 
NewCites[1] = ttmedcites[1] 
NewCites[2] = ttmedcites[2] 
 
NewList     = rep(0,ttN) 
NewList[1]  = 1 
NewList[2]  = 2 
 
for (i in 3:ttN){ 
  FoundPlace = F 
  j = 2 
  AtEnd = F 
  while (FoundPlace == F) {  
    if (ttmedcites[i] > NewCites[j])  
      {FoundPlace = T} 
    else { 
      j = j + 1 
      if (j == i) { 
        FoundPlace = T 
        AtEnd = T 
      } 
    } 
  } 
  if (AtEnd == T){ 
    NewList[i] = i 
    NewCites[i] = ttmedcites[i] } 
  else { 
    k = i 
    while (k > j) { 
      NewList[k]  = NewList[k-1] 
      NewCites[k] = NewCites[k-1] 
      k = k - 1 
    } 
    NewList[j] = i 
    NewCites[j] = ttmedcites[i] 
  } 
} 
       
 
#### For Actual th tanks (not mega think tanks), create New Th tank ID ### 
 
NewThTaID = rep(0,TotalObs) 
for (i in 1:ActualThTaN){ 
  NewThTaID = ifelse(ThTaID == NewList[i],i,NewThTaID) 
} 
 
       
###### Compute Cut Points for Mega Think tanks  ########## 
# Of the think tanks that are lumped into one of the Mega categories, 
# the program computes the min ttav (ttav = the ave. score of legislators citing the  
# think tank) and the max ttav.  It then defines cut points to create  
# equal distances between the min and max ttav.  E.g. if the min ttav is 5, the 
# max ttav is 85, and there are four mega think tanks, then the three cut points 
# are 25, 45, and 65. 
 
# Create starting values for min.ttav and max.ttav 
min.ttav = ttav[ActualThTaN + 1] 
max.ttav = ttav[ActualThTaN + 1] 
 
for (i in (ActualThTaN+2):ttN){ 
  if (ttav[i] < min.ttav) { min.ttav = ttav[i] } 
  if (ttav[i] > max.ttav) { max.ttav = ttav[i] } 
} 
 
MegaCutPoint = rep(0,MegaThTaN-1) 
for (i in 1:(MegaThTaN - 1)){ 
  MegaCutPoint[i] = min.ttav + (i/MegaThTaN)*(max.ttav - min.ttav) 
} 
 
 
for (i in (ActualThTaN+1):ttN){ 
  FoundPlace = F 
  j = 1 
  while ((FoundPlace == F) & (j < MegaThTaN)){ 
    if (ttav[NewList[i]] < MegaCutPoint[j]){ 
      FoundPlace = T} 
    else { 
      j = j + 1 
    } 
  } 
  # Now Think Tank NewList[i] belongs in MegaThTa j 
  NewThTaID = ifelse(ThTaID == NewList[i],ActualThTaN+j,NewThTaID) 
} 
 
 
######################################################################### 
 
### Compute new values for num. of cites and ttav (for mega th t's) ##### 
 
ttN = ActualThTaN + MegaThTaN 
 
######## Compute Ave. Sco. of legislators citing th. tank j ############# 
  
new.getav = function(j){ 
  cong.cite.true = ifelse(NewsID ==0 & NewThTaID == j,1,0) 
  cong.cite.sc <- ifelse(NewsID ==0 & NewThTaID == j,AvReSc99,0) 
  ttavTem=sum(cong.cite.sc)/sum(cong.cite.true) 
  ttavTem 
} 
 
pp = 1:ttN 
new.ttav = sapply(pp, new.getav) 
 
#### Compute number of cites by ALL (cong and media) to th tank j ####### 
 
get.all.cites = function(j){ 
  cite.true = ifelse(NewThTaID == j,1,0) 
  ttcitesTem=sum(cite.true) 
  ttcitesTem 
} 
 
pp = 1:ttN 
tt.all.cites = sapply(pp, get.all.cites)       
